"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getDateNow = void 0;
const quidproquo_core_1 = require("quidproquo-core");
const file_1 = __importDefault(require("../file"));
const config_1 = __importDefault(require("../config"));
const quidproquo_actionprocessor_node_1 = require("quidproquo-actionprocessor-node");
const awsLambdaUtils_1 = require("./../../../awsLambdaUtils");
const getDateNow = () => new Date().toISOString();
exports.getDateNow = getDateNow;
const getProcessExecuteStory = (runtimeConfig) => {
    return (payload, session) => __awaiter(void 0, void 0, void 0, function* () {
        let module = yield (0, awsLambdaUtils_1.loadModule)(payload.src);
        if (module === null) {
            return (0, quidproquo_core_1.actionResultError)(quidproquo_core_1.ErrorTypeEnum.NotFound, `Module not found [${payload.src}]`);
        }
        const story = module[payload.runtime];
        if (!story) {
            return (0, quidproquo_core_1.actionResultError)(quidproquo_core_1.ErrorTypeEnum.NotFound, `[${payload.runtime}] not found in module [${payload.src}]`);
        }
        const logger = (result) => __awaiter(void 0, void 0, void 0, function* () {
            // return await addResult(service, getDateNow(), payload.params[0][0].path, 'user-route', payload.src, payload.runtime, result);
        });
        const allActionProcessors = Object.assign(Object.assign(Object.assign(Object.assign({}, quidproquo_actionprocessor_node_1.coreActionProcessor), quidproquo_actionprocessor_node_1.webserverActionProcessor), (0, file_1.default)(runtimeConfig)), (0, config_1.default)(runtimeConfig));
        const resolveStory = (0, quidproquo_core_1.createRuntime)(session, allActionProcessors, exports.getDateNow, logger, awsLambdaUtils_1.randomGuid);
        const storyResult = yield resolveStory(story, payload.params);
        if (storyResult.error) {
            return (0, quidproquo_core_1.actionResultError)(storyResult.error.errorType, `story error! in ${payload.src}::${payload.runtime} -> [${storyResult.error.errorText}]`, storyResult.error.errorStack);
        }
        return (0, quidproquo_core_1.actionResult)({
            result: storyResult.result,
            session: storyResult.session,
        });
    });
};
exports.default = (runtimeConfig) => {
    // const appName = qpqCoreUtils.getAppName(config);
    return {
        [quidproquo_core_1.SystemActionType.ExecuteStory]: getProcessExecuteStory(runtimeConfig),
    };
};
